angular.module('app.controllers', [])
  
.controller('languageCtrl', ['$scope', '$stateParams', '$state', '$translate', 'LanguageService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $state, $translate, LanguageService) {
    $scope.langlist = [];
    $scope.$on('$ionicView.afterEnter', function() {
        $scope.langlist = LanguageService.languages();
        var items = ['HEADER_Language'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
        if (($stateParams.initial == 1) && (LanguageService.getLanguage() !== null)) {
            $translate.use(LanguageService.getLanguage());
            $state.go('Menu.techniques');
        }
    });
    $scope.goLanguage = function($index) {
        //console.log(LanguageService.language($index).code);
        LanguageService.setLanguage(LanguageService.language($index).code);
        $translate.use(LanguageService.getLanguage());
        $state.go('Menu.techniques');
    };
}
])
   
.controller('MenuCtrl', ['$scope', '$stateParams', '$translate', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate) {
    $scope.$on('$ionicView.afterEnter', function() {
        $translate('HEADER_Menu').then(function (text) { $scope.Menu = text; }, function (textId) { $scope.Menu = textId; });

        var items = ['HEADER_Main','HEADER_Techniques','ABOUT_AboutUs','ABOUT_AboutTrainer','MENU_FollowUs','HEADER_Settings','HEADER_Progress','HEADER_Share'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
    $scope.aboutUs = function() {
        window.open('http://www.colorss.org/', '_system', 'location=yes');
    };
}
])
   
.controller('dashboardCtrl', ['$scope', '$stateParams', '$translate', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['MISC_ColorssSelfDefense','MENU_Technique','MENU_Practice','MENU_FollowUs','MENU_AboutTrainerAndUs'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
}
])
   
.controller('techniquesCtrl', ['$scope', '$state', '$translate', '$stateParams', 'TechniquesService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $state, $translate, $stateParams, TechniquesService) {
    $scope.techlist = [];
    $scope.$on('$ionicView.afterEnter', function() {
        $scope.techlist = JSON.parse(JSON.stringify(TechniquesService.techniques()));
        $scope.techlist.forEach(function(item) {
            $translate(item.title).then(function (text) { item.title = text; }, function (textId) { item.title = textId; });
            $translate(item.desc).then(function (text) { item.desc = text; }, function (textId) { item.desc = textId; });
        });

        var items = ['HEADER_Techniques'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });

    });
    $scope.goTechnique = function(index) {
        $state.go('Menu.technique', {technique:index+1});
    };
}
])
   
.controller('techniqueCtrl', ['$scope', '$state', '$stateParams', '$translate', 'TechniquesService', 'ProgressService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $state, $stateParams, $translate, TechniquesService, ProgressService) {
    $scope.start = 0;
    $scope.technique = 1;
    $scope.steplist = [];
    $scope.learnimg = 'Learn0.svg';
    $scope.practiceimg = 'Practice0.svg';
    $scope.$on('$ionicView.afterEnter', function() {
        $scope.learnimg = (ProgressService.getLearnProgress($stateParams.technique)) ? 'Learn1.svg' : 'Learn0.svg';
        $scope.practiceimg = (ProgressService.getPracticeProgress($stateParams.technique)) ? 'Practice1.svg' : 'Practice0.svg';
        var techTitle = 'TECH_Title' + ("0" + $stateParams.technique.toString()).slice(-2);
        $scope.steplist = JSON.parse(JSON.stringify(TechniquesService.technique($stateParams.technique)));
        $scope.steplist.forEach(function(item) {
            //$translate(item.title).then(function (text) { item.title = text; }, function (textId) { item.title = textId; });
            //$translate(item.desc).then(function (text) { item.desc = text; }, function (textId) { item.desc = textId; });
            $translate(item.text).then(function (text) { item.desc = text; }, function (textId) { item.desc = textId; });
            $translate(techTitle).then(function (text) { item.title = text; }, function (textId) { item.title = textId; });
        });
        $scope.stepone = $scope.steplist[0];

        var items = ['HEADER_Technique','HEADER_Learn','HEADER_Practice', 'HEADER_Start', 'START_Practice'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
    $scope.goStep = function(index) {
        $state.go('Menu.lesson', {technique:$stateParams.technique,step:index+1});
    };
    $scope.showStart = function() {
        $scope.start = 1;
    };
    $scope.goLearn = function() {
        $state.go('Menu.lesson', {technique:$stateParams.technique,step:1});
    };
    $scope.goPractice = function() {
        $state.go('Menu.practice', {technique:$stateParams.technique,step:1});
    };
}
])
   
.controller('lessonCtrl', ['$scope', '$stateParams', '$state', '$ionicSlideBoxDelegate', '$timeout', '$translate', 'TechniquesService', 'ProgressService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $state, $ionicSlideBoxDelegate, $timeout, $translate, TechniquesService, ProgressService) {
    $scope.slider = null;
    $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
        $scope.slider = data.slider; // data.slider is the instance of Swiper
        //console.log($scope.slider);
    });
    $scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
        if ($scope.slider.activeIndex == $scope.steps.length - 1)
            ProgressService.setLearnProgress($stateParams.technique, 1);
    });
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_Lesson', 'HEADER_Congratulations', 'PRACTICE_Complete', 'PRACTICE_Next', 'PRACTICE_Learn', 'PRACTICE_Practice', 'PRACTICE_Back'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
        //console.log($stateParams.technique + ' - ' + $stateParams.step);
        $scope.steps = JSON.parse(JSON.stringify(TechniquesService.technique($stateParams.technique)));
        $scope.steps.push(JSON.parse(JSON.stringify($scope.steps[$scope.steps.length - 1])));
        var i = 1;
        $scope.steps.forEach(function(item) {
            item.pct = 100 * i / $scope.steps.length;
            $translate(item.text).then(function (text) { item.text = text; }, function (textId) { item.text = textId; });
            i++;
        });

        $ionicSlideBoxDelegate.update();
        $timeout(function() {
            if ($scope.slider) {
                $scope.slider.slideTo($stateParams.step-1, 0);
            }
        }, 500);
    });
    $scope.prev = function() {
        if ($scope.slider) {
            $scope.slider.slidePrev(0);
        }
    };
    $scope.next = function() {
        if ($scope.slider) {
            $scope.slider.slideNext(0);
            if ($scope.slider.activeIndex == $scope.steps.length - 1)
                ProgressService.setLearnProgress($stateParams.technique, 1);
        }
    };
    $scope.doLearn = function() {
        //$state.go('Menu.lesson', {technique:$stateParams.technique,step:1});
        $scope.slider.slideTo(0, 0);
    };
    $scope.doPractice = function() {
        $state.go('Menu.practice', {technique:$stateParams.technique,step:1});
    };
    $scope.doBack = function() {
        $state.go('Menu.techniques');
    };
}
])
   
.controller('practiceCtrl', ['$scope', '$state', '$stateParams', '$interval', '$timeout', '$translate', 'TechniquesService', 'ProgressService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $state, $stateParams, $interval, $timeout, $translate, TechniquesService, ProgressService) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_Practice', 'HEADER_Congratulations', 'PRACTICE_Complete', 'PRACTICE_Next', 'PRACTICE_Learn', 'PRACTICE_Practice', 'PRACTICE_Back'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
        //console.log($stateParams.technique + ' - ' + $stateParams.step);
        $scope.steps = JSON.parse(JSON.stringify(TechniquesService.technique($stateParams.technique)));
        var i = 1;
        $scope.steps.forEach(function(item) {
            item.pct = 100 * i / $scope.steps.length;
            $translate(item.text).then(function (text) { item.text = text; }, function (textId) { item.text = textId; });
            i++;
        });
        $scope.ffwdStyle = 'energized';
        $scope.ffwd = false;
        $scope.pause = false;
        $scope.end = 0;
        $scope.index = 0;
        $scope.step = $scope.steps[$scope.index];
        $scope.pct = 0;
        $scope.timer = $interval(function() {
            if ($scope.pause) return;
            if ($scope.ffwd) $scope.pct += 0.1;
            $scope.pct += 0.1;
            if ($scope.pct >= 100) {
                $scope.pct = 0;
                $scope.index++;
                if ($scope.index >= $scope.steps.length) {
                    ProgressService.setPracticeProgress($stateParams.technique, 1);
                    $scope.index = $scope.steps.length - 1;
                    $scope.end = 1;
                }
                $scope.step = $scope.steps[$scope.index];
            }
        }, 10);
    });
    $scope.$on('$ionicView.beforeLeave', function() {
        $interval.cancel($scope.timer);
    });
    $scope.doFfwd = function() {
        $scope.ffwd = !$scope.ffwd;
        if ($scope.ffwd === true) $scope.pause = false;
    };
    $scope.doPause = function() {
        $scope.pause = !$scope.pause;
        if ($scope.pause === true) $scope.ffwd = false;
    };
    $scope.doLearn = function() {
        $state.go('Menu.lesson', {technique:$stateParams.technique,step:1});
    };
    $scope.doPractice = function() {
        $scope.ffwdStyle = 'energized';
        $scope.ffwd = false;
        $scope.pause = false;
        $scope.end = 0;
        $scope.index = 0;
        $scope.step = $scope.steps[$scope.index];
        $scope.pct = 0;
    };
    $scope.doBack = function() {
        $state.go('Menu.techniques');
    };
}
])
   
.controller('followUsOnCtrl', ['$scope', '$stateParams', '$translate', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate) {
    $scope.socials = [
        {"name": "Facebook", "icon": "ion-social-facebook", "link": "https://www.facebook.com/colorssfoundation"},
        {"name": "Twitter", "icon": "ion-social-twitter", "link": "https://twitter.com/colorss"},
        {"name": "Google+", "icon": "ion-social-googleplus", "link": "https://plus.google.com/+ColorssFoundation"},
        {"name": "YouTube", "icon": "ion-social-youtube", "link": "http://www.youtube.com/user/colorssfoundation"},
        {"name": "Instagram", "icon": "ion-social-instagram", "link": "http://instagram.com/colorssfoundation"},
        {"name": "Pinterest", "icon": "ion-social-pinterest", "link": "https://www.pinterest.com/colorsss/"},
    ];
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_FollowUsOn'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
    $scope.goToLink = function(index) {
        window.open($scope.socials[index].link, '_system', 'location=yes');
    };
}
])
   
.controller('aboutUsCtrl', ['$scope', '$stateParams', '$translate', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_AboutUs','ABOUT_AboutUs','ABOUT_AboutTrainer'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
}
])
   
.controller('trainerCtrl', ['$scope', '$stateParams', '$translate', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_Trainer','TRAINER_Desc'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
}
])
   
.controller('settingsCtrl', ['$scope', '$stateParams', '$state', '$translate', '$ionicPopup', 'ProgressService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $state, $translate, $ionicPopup, ProgressService) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_Settings','SETTINGS_Sound','SETTINGS_ChangeLanguage', 'SETTINGS_ResetProgress',
            'HEADER_Share', 'MISC_AreYouSure', 'MISC_Yes', 'MISC_No', 'MISC_ColorssSelfDefense', 'SHARE_Text'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
    $scope.changeLanguage = function() {
        $state.go('language', {initial: 0});
    };
    $scope.resetProgress = function() {
        $ionicPopup.show({
            title: $scope.MISC_AreYouSure,
            cssClass: 'csdPopup',
            buttons: [
                { text: $scope.MISC_Yes,
                type: 'button-assertive button-outline',
                onTap: function(e) {
                    ProgressService.clearProgress();
                } },
                { text: $scope.MISC_No, type: 'button-assertive button-outline' }
            ]
        });
    };
    $scope.share = function() {
        console.log($scope.SHARE_Text + " http://onelink.to/3skqc3");
        //$cordovaSocialSharing.share(message, subject, file, link);
        //$cordovaSocialSharing.share($scope.SHARE_Text + " http://onelink.to/3skqc3", $scope.MISC_ColorssSelfDefense, null, null);
        window.plugins.socialsharing.share($scope.SHARE_Text + " http://onelink.to/3skqc3", $scope.MISC_ColorssSelfDefense, null, null);
    };
}
])
   
.controller('progressCtrl', ['$scope', '$stateParams', '$translate', 'ProgressService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate, ProgressService) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_Progress','HEADER_Learn','HEADER_Practice'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
        $scope.foo = true;
    });
    $scope.learnProgress = function(index) {
        return ProgressService.getLearnProgress(index);
    };
    $scope.practiceProgress = function(index) {
        return ProgressService.getPracticeProgress(index);
    };
    $scope.allLearn = function() {
        var total = 0;
        for (var i = 1; i <= 9; i++)
            total += ProgressService.getLearnProgress(i);
        return (total == 9);
    };
    $scope.allPractice = function() {
        var total = 0;
        for (var i = 1; i <= 9; i++)
            total += ProgressService.getPracticeProgress(i);
        return (total == 9);
    };
}
])
   
.controller('shareCtrl', ['$scope', '$stateParams', '$translate', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $translate) {
    $scope.$on('$ionicView.afterEnter', function() {
        var items = ['HEADER_Share'];
        items.forEach(function(item) {
            $translate(item).then(function (text) { $scope[item] = text; }, function (textId) { $scope[item] = textId; });
        });
    });
}
])
 