angular.module('app.routes', [])

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider
    

      .state('language', {
    url: '/page1',
	params: {
		initial: "1"		
},
    templateUrl: 'templates/language.html',
    controller: 'languageCtrl'
  })

  .state('Menu', {
    url: '/side-menu21',
    templateUrl: 'templates/Menu.html',
    controller: 'MenuCtrl'
  })

  .state('Menu.dashboard', {
    url: '/dashboard',
    views: {
      'side-menu21': {
        templateUrl: 'templates/dashboard.html',
        controller: 'dashboardCtrl'
      }
    }
  })

  .state('Menu.techniques', {
    url: '/techniques',
    views: {
      'side-menu21': {
        templateUrl: 'templates/techniques.html',
        controller: 'techniquesCtrl'
      }
    }
  })

  .state('Menu.technique', {
    url: '/technique',
	params: {
		technique: "1"		
},
    views: {
      'side-menu21': {
        templateUrl: 'templates/technique.html',
        controller: 'techniqueCtrl'
      }
    }
  })

  .state('Menu.lesson', {
    url: '/lesson',
	params: {
		technique: "1",
		step: "1"		
},
    views: {
      'side-menu21': {
        templateUrl: 'templates/lesson.html',
        controller: 'lessonCtrl'
      }
    }
  })

  .state('Menu.practice', {
    url: '/practice',
	params: {
		technique: "1",
		step: "1"		
},
    views: {
      'side-menu21': {
        templateUrl: 'templates/practice.html',
        controller: 'practiceCtrl'
      }
    }
  })

  .state('Menu.followUsOn', {
    url: '/followUsOn',
    views: {
      'side-menu21': {
        templateUrl: 'templates/followUsOn.html',
        controller: 'followUsOnCtrl'
      }
    }
  })

  .state('aboutUs', {
    url: '/aboutUs',
    templateUrl: 'templates/aboutUs.html',
    controller: 'aboutUsCtrl'
  })

  .state('Menu.trainer', {
    url: '/trainer',
    views: {
      'side-menu21': {
        templateUrl: 'templates/trainer.html',
        controller: 'trainerCtrl'
      }
    }
  })

  .state('Menu.settings', {
    url: '/settings',
    views: {
      'side-menu21': {
        templateUrl: 'templates/settings.html',
        controller: 'settingsCtrl'
      }
    }
  })

  .state('Menu.progress', {
    url: '/progress',
    views: {
      'side-menu21': {
        templateUrl: 'templates/progress.html',
        controller: 'progressCtrl'
      }
    }
  })

  .state('Menu.share', {
    url: '/share',
    views: {
      'side-menu21': {
        templateUrl: 'templates/share.html',
        controller: 'shareCtrl'
      }
    }
  })

$urlRouterProvider.otherwise('/page1')


});