angular.module('app.services', [])

//.factory('BlankFactory', [function(){
//}])
.service('ProgressService', [function(){
    var learnKey = 'org.colorss.learnprogress';
    var practiceKey = 'org.colorss.practiceprogress';
    var learnProgress = [0,0,0,0,0,0,0,0,0,0];
    var practiceProgress = [0,0,0,0,0,0,0,0,0,0];
    return {
        getLearnProgress: function (index) {
            if (window.localStorage.getItem(learnKey) !== null)
                learnProgress = JSON.parse(window.localStorage.getItem(learnKey));
            return learnProgress[index];
        },
        getPracticeProgress: function (index) {
            if (window.localStorage.getItem(practiceKey) !== null)
                practiceProgress = JSON.parse(window.localStorage.getItem(practiceKey));
            return practiceProgress[index];
        },
        setLearnProgress: function (index, value) {
            learnProgress[index] = value;
            window.localStorage.setItem(learnKey, JSON.stringify(learnProgress));
        },
        setPracticeProgress: function (index, value) {
            practiceProgress[index] = value;
            window.localStorage.setItem(practiceKey, JSON.stringify(practiceProgress));
        },
        clearProgress: function () {
            for (var i = 1; i <= 9; i++) {
                this.setLearnProgress(i, 0);
                this.setPracticeProgress(i, 0);
            }
        }
    };
}])

.service('LanguageService', [function(){
    var languageKey = 'org.colorss.language';
    var langlist = [
        {language:"English",code:"en"},
        {language:"Arabic (العَرَبِيَّة / عَرَبِيّ)",code:"ar"},
        {language:"Assamese (অসমীয়া)",code:"as"},
        {language:"Bengali (বাংলা)",code:"bn"},
        {language:"Chinese (中文)",code:"zh"},
        {language:"Gujarati (ગુજરાતી)",code:"gu"},
        {language:"Hindi (हिन्दी)",code:"hi"},
        {language:"Japanese (日本語)",code:"ja"},
        {language:"Kannada (ಕನ್ನಡ)",code:"kn"},
        {language:"Malayalam (മലയാളം)",code:"ml"},
        {language:"Marathi (मराठी)",code:"mr"},
        {language:"Nepali (नेपाली भाषा)",code:"ne"},
        {language:"Oriya (ଓଡ଼ିଆ ଭାଷା)",code:"or"},
        {language:"Portuguese (Português)",code:"pt"},
        {language:"Punjabi (ਪੰਜਾਬੀ)",code:"pa"},
        {language:"Russian (русский язык)",code:"ru"},
        {language:"Spanish (Español)",code:"es"},
        {language:"Tamil (தமிழ்)",code:"ta"},
        {language:"Telugu (తెలుగు)",code:"te"},
        {language:"Urdu (اُردُو)",code:"ur"},
    ];
    return {
        language: function (index) {
            return langlist[index];
        },
        languages: function () {
            return langlist;
        },
        getLanguage: function () {
            return window.localStorage.getItem(languageKey);
        },
        setLanguage: function (value) {
            window.localStorage.setItem(languageKey, value);
        },
    };
}])

.service('TechniquesService', [function(){
    var techlist = [
        {title:"TECH_Title01",desc:"TECH_Desc01",pic:"techlist/tech_01.jpg",
            steps:[
                {title:"TECH_Title0101",desc:"TECH_Desc0101",pic:"tech/tech_0101.jpg",text:"TECH_Text0101"},
                {title:"TECH_Title0102",desc:"TECH_Desc0102",pic:"tech/tech_0102.jpg",text:"TECH_Text0102"},
                {title:"TECH_Title0103",desc:"TECH_Desc0103",pic:"tech/tech_0103.jpg",text:"TECH_Text0103"},
                {title:"TECH_Title0104",desc:"TECH_Desc0104",pic:"tech/tech_0104.jpg",text:"TECH_Text0104"},
                {title:"TECH_Title0105",desc:"TECH_Desc0105",pic:"tech/tech_0105.jpg",text:"TECH_Text0105"},
                {title:"TECH_Title0106",desc:"TECH_Desc0106",pic:"tech/tech_0106.jpg",text:"TECH_Text0106"},
            ]
        },
        {title:"TECH_Title02",desc:"TECH_Desc02",pic:"techlist/tech_02.jpg",
            steps:[
                {title:"TECH_Title0201",desc:"TECH_Desc0201",pic:"tech/tech_0201.jpg",text:"TECH_Text0201"},
                {title:"TECH_Title0202",desc:"TECH_Desc0202",pic:"tech/tech_0202.jpg",text:"TECH_Text0202"},
                {title:"TECH_Title0203",desc:"TECH_Desc0203",pic:"tech/tech_0203.jpg",text:"TECH_Text0203"},
                {title:"TECH_Title0204",desc:"TECH_Desc0204",pic:"tech/tech_0204.jpg",text:"TECH_Text0204"},
                {title:"TECH_Title0205",desc:"TECH_Desc0205",pic:"tech/tech_0205.jpg",text:"TECH_Text0205"},
            ]
        },
        {title:"TECH_Title03",desc:"TECH_Desc03",pic:"techlist/tech_03.jpg",
            steps:[
                {title:"TECH_Title0301",desc:"TECH_Desc0301",pic:"tech/tech_0301.jpg",text:"TECH_Text0301"},
                {title:"TECH_Title0302",desc:"TECH_Desc0302",pic:"tech/tech_0302.jpg",text:"TECH_Text0302"},
                {title:"TECH_Title0303",desc:"TECH_Desc0303",pic:"tech/tech_0303.jpg",text:"TECH_Text0303"},
                {title:"TECH_Title0304",desc:"TECH_Desc0304",pic:"tech/tech_0304.jpg",text:"TECH_Text0304"},
                {title:"TECH_Title0305",desc:"TECH_Desc0305",pic:"tech/tech_0305.jpg",text:"TECH_Text0305"},
                {title:"TECH_Title0306",desc:"TECH_Desc0306",pic:"tech/tech_0306.jpg",text:"TECH_Text0306"},
            ]
        },
        {title:"TECH_Title04",desc:"TECH_Desc04",pic:"techlist/tech_04.jpg",
            steps:[
                {title:"TECH_Title0401",desc:"TECH_Desc0401",pic:"tech/tech_0401.jpg",text:"TECH_Text0401"},
                {title:"TECH_Title0402",desc:"TECH_Desc0402",pic:"tech/tech_0402.jpg",text:"TECH_Text0402"},
                {title:"TECH_Title0403",desc:"TECH_Desc0403",pic:"tech/tech_0403.jpg",text:"TECH_Text0403"},
                {title:"TECH_Title0404",desc:"TECH_Desc0404",pic:"tech/tech_0404.jpg",text:"TECH_Text0404"},
                {title:"TECH_Title0405",desc:"TECH_Desc0405",pic:"tech/tech_0405.jpg",text:"TECH_Text0405"},
            ]
        },
        {title:"TECH_Title05",desc:"TECH_Desc05",pic:"techlist/tech_05.jpg",
            steps:[
                {title:"TECH_Title0501",desc:"TECH_Desc0501",pic:"tech/tech_0501.jpg",text:"TECH_Text0501"},
                {title:"TECH_Title0502",desc:"TECH_Desc0502",pic:"tech/tech_0502.jpg",text:"TECH_Text0502"},
                {title:"TECH_Title0503",desc:"TECH_Desc0503",pic:"tech/tech_0503.jpg",text:"TECH_Text0503"},
            ]
        },
        {title:"TECH_Title06",desc:"TECH_Desc06",pic:"techlist/tech_06.jpg",
            steps:[
                {title:"TECH_Title0601",desc:"TECH_Desc0601",pic:"tech/tech_0601.jpg",text:"TECH_Text0601"},
                {title:"TECH_Title0602",desc:"TECH_Desc0602",pic:"tech/tech_0602.jpg",text:"TECH_Text0602"},
                {title:"TECH_Title0603",desc:"TECH_Desc0603",pic:"tech/tech_0603.jpg",text:"TECH_Text0603"},
            ]
        },
        {title:"TECH_Title07",desc:"TECH_Desc07",pic:"techlist/tech_07.jpg",
            steps:[
                {title:"TECH_Title0701",desc:"TECH_Desc0701",pic:"tech/tech_0701.jpg",text:"TECH_Text0701"},
                {title:"TECH_Title0702",desc:"TECH_Desc0702",pic:"tech/tech_0702.jpg",text:"TECH_Text0702"},
                {title:"TECH_Title0703",desc:"TECH_Desc0703",pic:"tech/tech_0703.jpg",text:"TECH_Text0703"},
            ]
        },
        {title:"TECH_Title08",desc:"TECH_Desc08",pic:"techlist/tech_08.jpg",
            steps:[
                {title:"TECH_Title0801",desc:"TECH_Desc0801",pic:"tech/tech_0801.jpg",text:"TECH_Text0801"},
                {title:"TECH_Title0802",desc:"TECH_Desc0802",pic:"tech/tech_0802.jpg",text:"TECH_Text0802"},
                {title:"TECH_Title0803",desc:"TECH_Desc0803",pic:"tech/tech_0803.jpg",text:"TECH_Text0803"},
            ]
        },
        {title:"TECH_Title09",desc:"TECH_Desc09",pic:"techlist/tech_09.jpg",
            steps:[
                {title:"TECH_Title0901",desc:"TECH_Desc0901",pic:"tech/tech_0901.jpg",text:"TECH_Text0901"},
                {title:"TECH_Title0902",desc:"TECH_Desc0902",pic:"tech/tech_0902.jpg",text:"TECH_Text0902"},
                {title:"TECH_Title0903",desc:"TECH_Desc0903",pic:"tech/tech_0903.jpg",text:"TECH_Text0903"},
                {title:"TECH_Title0904",desc:"TECH_Desc0904",pic:"tech/tech_0904.jpg",text:"TECH_Text0904"},
                {title:"TECH_Title0905",desc:"TECH_Desc0905",pic:"tech/tech_0905.jpg",text:"TECH_Text0905"},
                {title:"TECH_Title0906",desc:"TECH_Desc0906",pic:"tech/tech_0906.jpg",text:"TECH_Text0906"},
                {title:"TECH_Title0907",desc:"TECH_Desc0907",pic:"tech/tech_0907.jpg",text:"TECH_Text0907"},
            ]
        }
    ];
    return {
        technique: function (index) {
            //return "foon";
            return techlist[(index>0) ? index-1 : 0].steps;
        },
        techniques: function () {
            //return "foon";
            return techlist;
        }
    };
}]);
